Index: contrib/bazaar/mbprotect/__init__.py
===================================================================
--- contrib/bazaar/mbprotect/__init__.py	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ contrib/bazaar/mbprotect/__init__.py	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -33,5 +33,5 @@
 # branch (a.k.a. linear history) of bzr repositories from unwanted change,
 # effectively making the main branch append-only.
-#
+# 
 # Specifically we verify that the new main branch contains the old tip.
 # This prevents a branch from inadvertently aquiring the tip of another branch.
@@ -46,26 +46,27 @@
 
 def pre_change_branch_tip(params):
-	repo = params.branch.repository
-	
-	# Check if the old repository was empty.
-	if params.old_revid == 'null:':
-		return
-	
-	# First permitted case is appending changesets to main branch.Look for
-	# old tip in new main branch.
-	for revision_id in repo.iter_reverse_revision_history(params.new_revid):
-		if revision_id == params.old_revid:
-			return	# Found old tip
-	
-	# Another permitted case is backing out changesets. Look for new tip
-	# in old branch.
-	for revision_id in repo.iter_reverse_revision_history(params.old_revid):
-		if revision_id == params.new_revid:
-			return	# Found new tip
-	
-	# Trying to do something else. Reject the change.
-	raise TipChangeRejected('Bad tip. Read http://trac.helenos.org/wiki/BazaarWorkflow')
+    repo = params.branch.repository
+
+    # Check if the old repository was empty.
+    if params.old_revid == 'null:':
+	return
+
+    # First permitted case is appending changesets to main branch.Look for
+    # old tip in new main branch.
+    for revision_id in repo.iter_reverse_revision_history(params.new_revid):
+	if revision_id == params.old_revid:
+	    return	# Found old tip
+
+    # Another permitted case is backing out changesets. Look for new tip
+    # in old branch.
+    for revision_id in repo.iter_reverse_revision_history(params.old_revid):
+	if revision_id == params.new_revid:
+	    return	# Found new tip
+
+    # Trying to do something else. Reject the change.
+    raise TipChangeRejected('Bad tip. Read http://trac.helenos.org/trac.fcgi/' +
+	'wiki/BazaarWorkflow')
 
 # Install hook.
 bzrlib.branch.Branch.hooks.install_named_hook('pre_change_branch_tip',
-	pre_change_branch_tip, 'MB-Protect tip check')
+    pre_change_branch_tip, 'MB-Protect tip check')
Index: kernel/Makefile.build
===================================================================
--- kernel/Makefile.build	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/Makefile.build	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -56,6 +56,5 @@
 	-finput-charset=UTF-8 -ffreestanding -fno-builtin -nostdlib -nostdinc \
 	-Wall -Wextra -Wno-unused-parameter -Wmissing-prototypes \
-	-Werror-implicit-function-declaration -Wwrite-strings \
-	-Werror -pipe
+	-Werror-implicit-function-declaration -Werror -pipe
 
 ICC_CFLAGS = -I$(INCLUDES) -O$(OPTIMIZATION) -imacros ../config.h \
@@ -70,7 +69,6 @@
 	-fexec-charset=UTF-8 -fwide-exec-charset=UTF-32$(ENDIANESS) \
 	-finput-charset=UTF-8 -ffreestanding -fno-builtin -nostdlib -nostdinc \
-	-Wall -Wextra -Wno-unused-parameter -Wmissing-prototypes \
-	-Werror-implicit-function-declaration -Wwrite-strings \
-	-pipe -arch $(CLANG_ARCH)
+	-Wall -Wextra -Wno-unused-parameter -Wmissing-prototypes -pipe \
+	-arch $(CLANG_ARCH)
 
 LFLAGS = -M
Index: kernel/arch/abs32le/Makefile.inc
===================================================================
--- kernel/arch/abs32le/Makefile.inc	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/abs32le/Makefile.inc	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -50,8 +50,4 @@
 endif
 
-ifeq ($(COMPILER),clang)
-	CLANG_ARCH = i386
-endif
-
 BITS = 32
 ENDIANESS = LE
Index: kernel/arch/abs32le/include/atomic.h
===================================================================
--- kernel/arch/abs32le/include/atomic.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/abs32le/include/atomic.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -54,5 +54,5 @@
 }
 
-static inline atomic_count_t atomic_postinc(atomic_t *val)
+static inline long atomic_postinc(atomic_t *val)
 {
 	/* On real hardware both the storing of the previous
@@ -60,5 +60,5 @@
 	   atomic action. */
 	
-	atomic_count_t prev = val->count;
+	long prev = val->count;
 	
 	val->count++;
@@ -66,5 +66,5 @@
 }
 
-static inline atomic_count_t atomic_postdec(atomic_t *val)
+static inline long atomic_postdec(atomic_t *val)
 {
 	/* On real hardware both the storing of the previous
@@ -72,5 +72,5 @@
 	   atomic action. */
 	
-	atomic_count_t prev = val->count;
+	long prev = val->count;
 	
 	val->count--;
@@ -81,7 +81,7 @@
 #define atomic_predec(val)  (atomic_postdec(val) - 1)
 
-static inline atomic_count_t test_and_set(atomic_t *val)
+static inline uint32_t test_and_set(atomic_t *val)
 {
-	atomic_count_t prev = val->count;
+	uint32_t prev = val->count;
 	val->count = 1;
 	return prev;
Index: kernel/arch/abs32le/include/types.h
===================================================================
--- kernel/arch/abs32le/include/types.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/abs32le/include/types.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -55,5 +55,4 @@
 typedef uint32_t unative_t;
 typedef int32_t native_t;
-typedef uint32_t atomic_count_t;
 
 typedef struct {
Index: kernel/arch/abs32le/src/abs32le.c
===================================================================
--- kernel/arch/abs32le/src/abs32le.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/abs32le/src/abs32le.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -114,5 +114,5 @@
 }
 
-void panic_printf(const char *fmt, ...)
+void panic_printf(char *fmt, ...)
 {
 	va_list args;
Index: kernel/arch/amd64/include/atomic.h
===================================================================
--- kernel/arch/amd64/include/atomic.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/amd64/include/atomic.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -40,6 +40,5 @@
 #include <preemption.h>
 
-static inline void atomic_inc(atomic_t *val)
-{
+static inline void atomic_inc(atomic_t *val) {
 #ifdef CONFIG_SMP
 	asm volatile (
@@ -55,6 +54,5 @@
 }
 
-static inline void atomic_dec(atomic_t *val)
-{
+static inline void atomic_dec(atomic_t *val) {
 #ifdef CONFIG_SMP
 	asm volatile (
@@ -70,12 +68,11 @@
 }
 
-static inline atomic_count_t atomic_postinc(atomic_t *val)
+static inline long atomic_postinc(atomic_t *val) 
 {
-	atomic_count_t r = 1;
+	long r = 1;
 	
 	asm volatile (
 		"lock xaddq %[r], %[count]\n"
-		: [count] "+m" (val->count),
-		  [r] "+r" (r)
+		: [count] "+m" (val->count), [r] "+r" (r)
 	);
 	
@@ -83,12 +80,11 @@
 }
 
-static inline atomic_count_t atomic_postdec(atomic_t *val)
+static inline long atomic_postdec(atomic_t *val) 
 {
-	atomic_count_t r = -1;
+	long r = -1;
 	
 	asm volatile (
 		"lock xaddq %[r], %[count]\n"
-		: [count] "+m" (val->count),
-		  [r] "+r" (r)
+		: [count] "+m" (val->count), [r] "+r" (r)
 	);
 	
@@ -99,12 +95,11 @@
 #define atomic_predec(val)  (atomic_postdec(val) - 1)
 
-static inline atomic_count_t test_and_set(atomic_t *val)
-{
-	atomic_count_t v = 1;
+static inline uint64_t test_and_set(atomic_t *val) {
+	uint64_t v;
 	
 	asm volatile (
+		"movq $1, %[v]\n"
 		"xchgq %[v], %[count]\n"
-		: [v] "+r" (v),
-		  [count] "+m" (val->count)
+		: [v] "=r" (v), [count] "+m" (val->count)
 	);
 	
@@ -112,8 +107,9 @@
 }
 
+
 /** amd64 specific fast spinlock */
 static inline void atomic_lock_arch(atomic_t *val)
 {
-	atomic_count_t tmp;
+	uint64_t tmp;
 	
 	preemption_disable();
@@ -129,8 +125,6 @@
 		"testq %[tmp], %[tmp]\n"
 		"jnz 0b\n"
-		: [count] "+m" (val->count),
-		  [tmp] "=&r" (tmp)
+		: [count] "+m" (val->count), [tmp] "=&r" (tmp)
 	);
-	
 	/*
 	 * Prevent critical section code from bleeding out this way up.
Index: kernel/arch/amd64/include/types.h
===================================================================
--- kernel/arch/amd64/include/types.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/amd64/include/types.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -55,5 +55,4 @@
 typedef uint64_t unative_t;
 typedef int64_t native_t;
-typedef uint64_t atomic_count_t;
 
 typedef struct {
Index: kernel/arch/amd64/src/cpu/cpu.c
===================================================================
--- kernel/arch/amd64/src/cpu/cpu.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/amd64/src/cpu/cpu.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -62,5 +62,5 @@
 };
 
-static const char *vendor_str[] = {
+static char *vendor_str[] = {
 	"Unknown Vendor",
 	"AuthenticAMD",
Index: kernel/arch/amd64/src/debugger.c
===================================================================
--- kernel/arch/amd64/src/debugger.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/amd64/src/debugger.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -339,4 +339,5 @@
 {
 	unsigned int i;
+	char *symbol;
 
 #ifdef __32_BITS__
@@ -352,5 +353,5 @@
 	for (i = 0; i < BKPOINTS_MAX; i++)
 		if (breakpoints[i].address) {
-			const char *symbol = symtab_fmt_name_lookup(
+			symbol = symtab_fmt_name_lookup(
 			    breakpoints[i].address);
 
Index: kernel/arch/amd64/src/interrupt.c
===================================================================
--- kernel/arch/amd64/src/interrupt.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/amd64/src/interrupt.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -65,6 +65,8 @@
 void decode_istate(int n, istate_t *istate)
 {
-	const char *symbol = symtab_fmt_name_lookup(istate->rip);
-	
+	char *symbol;
+
+	symbol = symtab_fmt_name_lookup(istate->rip);
+
 	printf("-----EXCEPTION(%d) OCCURED----- ( %s )\n", n, __func__);
 	printf("%%rip: %#llx (%s)\n", istate->rip, symbol);
Index: kernel/arch/arm32/include/atomic.h
===================================================================
--- kernel/arch/arm32/include/atomic.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/arm32/include/atomic.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -47,6 +47,8 @@
  *
  */
-static inline atomic_count_t atomic_add(atomic_t *val, atomic_count_t i)
+static inline long atomic_add(atomic_t *val, int i)
 {
+	long ret;
+
 	/*
 	 * This implementation is for UP pre-ARMv6 systems where we do not have
@@ -55,5 +57,5 @@
 	ipl_t ipl = interrupts_disable();
 	val->count += i;
-	atomic_count_t ret = val->count;
+	ret = val->count;
 	interrupts_restore(ipl);
 	
@@ -64,5 +66,4 @@
  *
  * @param val Variable to be incremented.
- *
  */
 static inline void atomic_inc(atomic_t *val)
@@ -74,5 +75,4 @@
  *
  * @param val Variable to be decremented.
- *
  */
 static inline void atomic_dec(atomic_t *val) {
@@ -84,7 +84,6 @@
  * @param val Variable to be incremented.
  * @return    Value after incrementation.
- *
  */
-static inline atomic_count_t atomic_preinc(atomic_t *val)
+static inline long atomic_preinc(atomic_t *val)
 {
 	return atomic_add(val, 1);
@@ -95,7 +94,6 @@
  * @param val Variable to be decremented.
  * @return    Value after decrementation.
- *
  */
-static inline atomic_count_t atomic_predec(atomic_t *val)
+static inline long atomic_predec(atomic_t *val)
 {
 	return atomic_add(val, -1);
@@ -106,7 +104,6 @@
  * @param val Variable to be incremented.
  * @return    Value before incrementation.
- *
  */
-static inline atomic_count_t atomic_postinc(atomic_t *val)
+static inline long atomic_postinc(atomic_t *val)
 {
 	return atomic_add(val, 1) - 1;
@@ -117,7 +114,6 @@
  * @param val Variable to be decremented.
  * @return    Value before decrementation.
- *
  */
-static inline atomic_count_t atomic_postdec(atomic_t *val)
+static inline long atomic_postdec(atomic_t *val)
 {
 	return atomic_add(val, -1) + 1;
Index: kernel/arch/arm32/include/types.h
===================================================================
--- kernel/arch/arm32/include/types.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/arm32/include/types.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup arm32
+/** @addtogroup arm32	
  * @{
  */
@@ -38,7 +38,7 @@
 
 #ifndef DOXYGEN
-	#define ATTRIBUTE_PACKED __attribute__((packed))
+#	define ATTRIBUTE_PACKED __attribute__ ((packed))
 #else
-	#define ATTRIBUTE_PACKED
+#	define ATTRIBUTE_PACKED
 #endif
 
@@ -62,5 +62,4 @@
 typedef uint32_t unative_t;
 typedef int32_t native_t;
-typedef uint32_t atomic_count_t;
 
 typedef struct {
Index: kernel/arch/arm32/src/cpu/cpu.c
===================================================================
--- kernel/arch/arm32/src/cpu/cpu.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/arm32/src/cpu/cpu.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -43,5 +43,5 @@
 
 /** Implementators (vendor) names */
-static const char *imp_data[] = {
+static char *imp_data[] = {
 	"?",					/* IMP_DATA_START_OFFSET */
 	"ARM Ltd",				/* 0x41 */
@@ -60,5 +60,5 @@
 
 /** Architecture names */
-static const char *arch_data[] = {
+static char *arch_data[] = {
 	"?",       /* 0x0 */
 	"4",       /* 0x1 */
@@ -108,6 +108,6 @@
 void cpu_print_report(cpu_t *m)
 {
-	const char *vendor = imp_data[0];
-	const char *architecture = arch_data[0];
+	char * vendor = imp_data[0];
+	char * architecture = arch_data[0];
 	cpu_arch_t * cpu_arch = &m->arch;
 
Index: kernel/arch/ia32/include/atomic.h
===================================================================
--- kernel/arch/ia32/include/atomic.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/ia32/include/atomic.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -40,6 +40,5 @@
 #include <preemption.h>
 
-static inline void atomic_inc(atomic_t *val)
-{
+static inline void atomic_inc(atomic_t *val) {
 #ifdef CONFIG_SMP
 	asm volatile (
@@ -55,6 +54,5 @@
 }
 
-static inline void atomic_dec(atomic_t *val)
-{
+static inline void atomic_dec(atomic_t *val) {
 #ifdef CONFIG_SMP
 	asm volatile (
@@ -70,12 +68,11 @@
 }
 
-static inline atomic_count_t atomic_postinc(atomic_t *val)
+static inline long atomic_postinc(atomic_t *val) 
 {
-	atomic_count_t r = 1;
+	long r = 1;
 	
 	asm volatile (
 		"lock xaddl %[r], %[count]\n"
-		: [count] "+m" (val->count),
-		  [r] "+r" (r)
+		: [count] "+m" (val->count), [r] "+r" (r)
 	);
 	
@@ -83,12 +80,11 @@
 }
 
-static inline atomic_count_t atomic_postdec(atomic_t *val)
+static inline long atomic_postdec(atomic_t *val) 
 {
-	atomic_count_t r = -1;
+	long r = -1;
 	
 	asm volatile (
 		"lock xaddl %[r], %[count]\n"
-		: [count] "+m" (val->count),
-		  [r] "+r" (r)
+		: [count] "+m" (val->count), [r] "+r"(r)
 	);
 	
@@ -99,12 +95,11 @@
 #define atomic_predec(val)  (atomic_postdec(val) - 1)
 
-static inline atomic_count_t test_and_set(atomic_t *val)
-{
-	atomic_count_t v = 1;
+static inline uint32_t test_and_set(atomic_t *val) {
+	uint32_t v;
 	
 	asm volatile (
+		"movl $1, %[v]\n"
 		"xchgl %[v], %[count]\n"
-		: [v] "+r" (v),
-		  [count] "+m" (val->count)
+		: [v] "=r" (v), [count] "+m" (val->count)
 	);
 	
@@ -115,5 +110,5 @@
 static inline void atomic_lock_arch(atomic_t *val)
 {
-	atomic_count_t tmp;
+	uint32_t tmp;
 	
 	preemption_disable();
@@ -129,8 +124,6 @@
 		"testl %[tmp], %[tmp]\n"
 		"jnz 0b\n"
-		: [count] "+m" (val->count),
-		  [tmp] "=&r" (tmp)
+		: [count] "+m" (val->count), [tmp] "=&r" (tmp)
 	);
-	
 	/*
 	 * Prevent critical section code from bleeding out this way up.
Index: kernel/arch/ia32/include/types.h
===================================================================
--- kernel/arch/ia32/include/types.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/ia32/include/types.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -55,5 +55,4 @@
 typedef uint32_t unative_t;
 typedef int32_t native_t;
-typedef uint32_t atomic_count_t;
 
 typedef struct {
Index: kernel/arch/ia32/src/cpu/cpu.c
===================================================================
--- kernel/arch/ia32/src/cpu/cpu.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/ia32/src/cpu/cpu.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -64,5 +64,5 @@
 };
 
-static const char *vendor_str[] = {
+static char *vendor_str[] = {
 	"Unknown Vendor",
 	"AMD",
Index: kernel/arch/ia32/src/interrupt.c
===================================================================
--- kernel/arch/ia32/src/interrupt.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/ia32/src/interrupt.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -65,11 +65,13 @@
 void decode_istate(istate_t *istate)
 {
-	const char *symbol = symtab_fmt_name_lookup(istate->eip);
-	
+	char *symbol;
+
+	symbol = symtab_fmt_name_lookup(istate->eip);
+
 	if (CPU)
 		printf("----------------EXCEPTION OCCURED (cpu%u)----------------\n", CPU->id);
 	else
 		printf("----------------EXCEPTION OCCURED----------------\n");
-	
+		
 	printf("%%eip: %#lx (%s)\n", istate->eip, symbol);
 	printf("ERROR_WORD=%#lx\n", istate->error_word);
@@ -78,5 +80,5 @@
 	printf("stack: %#lx, %#lx, %#lx, %#lx\n", istate->stack[0], istate->stack[1], istate->stack[2], istate->stack[3]);
 	printf("       %#lx, %#lx, %#lx, %#lx\n", istate->stack[4], istate->stack[5], istate->stack[6], istate->stack[7]);
-	
+
 	stack_trace_istate(istate);
 }
Index: kernel/arch/ia32/src/mm/frame.c
===================================================================
--- kernel/arch/ia32/src/mm/frame.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/ia32/src/mm/frame.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup ia32mm
+/** @addtogroup ia32mm	
  * @{
  */
@@ -109,5 +109,5 @@
 }
 
-static const char *e820names[] = {
+static char *e820names[] = {
 	"invalid",
 	"available",
@@ -122,5 +122,5 @@
 {
 	unsigned int i;
-	const char *name;
+	char *name;
 	
 	printf("Base               Size               Name\n");
Index: kernel/arch/ia64/include/atomic.h
===================================================================
--- kernel/arch/ia64/include/atomic.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/ia64/include/atomic.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -36,8 +36,8 @@
 #define KERN_ia64_ATOMIC_H_
 
-static inline atomic_count_t test_and_set(atomic_t *val)
+static inline uint64_t test_and_set(atomic_t *val)
 {
-	atomic_count_t v;
-	
+	uint64_t v;
+		
 	asm volatile (
 		"movl %[v] = 0x1;;\n"
@@ -53,5 +53,6 @@
 {
 	do {
-		while (val->count);
+		while (val->count)
+			;
 	} while (test_and_set(val));
 }
@@ -59,5 +60,5 @@
 static inline void atomic_inc(atomic_t *val)
 {
-	atomic_count_t v;
+	long v;
 	
 	asm volatile (
@@ -70,5 +71,5 @@
 static inline void atomic_dec(atomic_t *val)
 {
-	atomic_count_t v;
+	long v;
 	
 	asm volatile (
@@ -79,7 +80,7 @@
 }
 
-static inline atomic_count_t atomic_preinc(atomic_t *val)
+static inline long atomic_preinc(atomic_t *val)
 {
-	atomic_count_t v;
+	long v;
 	
 	asm volatile (
@@ -92,7 +93,7 @@
 }
 
-static inline atomic_count_t atomic_predec(atomic_t *val)
+static inline long atomic_predec(atomic_t *val)
 {
-	atomic_count_t v;
+	long v;
 	
 	asm volatile (
@@ -105,7 +106,7 @@
 }
 
-static inline atomic_count_t atomic_postinc(atomic_t *val)
+static inline long atomic_postinc(atomic_t *val)
 {
-	atomic_count_t v;
+	long v;
 	
 	asm volatile (
@@ -118,7 +119,7 @@
 }
 
-static inline atomic_count_t atomic_postdec(atomic_t *val)
+static inline long atomic_postdec(atomic_t *val)
 {
-	atomic_count_t v;
+	long v;
 	
 	asm volatile (
Index: kernel/arch/ia64/include/types.h
===================================================================
--- kernel/arch/ia64/include/types.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/ia64/include/types.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup ia64
+/** @addtogroup ia64	
  * @{
  */
@@ -63,5 +63,4 @@
 typedef uint64_t unative_t;
 typedef int64_t native_t;
-typedef uint64_t atomic_count_t;
 
 typedef struct {
Index: kernel/arch/ia64/src/cpu/cpu.c
===================================================================
--- kernel/arch/ia64/src/cpu/cpu.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/ia64/src/cpu/cpu.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -52,5 +52,5 @@
 void cpu_print_report(cpu_t *m)
 {
-	const char *family_str;
+	char *family_str;
 	char vendor[2 * sizeof(uint64_t) + 1];
 	
Index: kernel/arch/ia64/src/interrupt.c
===================================================================
--- kernel/arch/ia64/src/interrupt.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/ia64/src/interrupt.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -64,5 +64,5 @@
 #define BUNDLE_SIZE		16
 
-static const char *vector_names_64_bundle[VECTORS_64_BUNDLE] = {
+char *vector_names_64_bundle[VECTORS_64_BUNDLE] = {
 	"VHPT Translation vector",
 	"Instruction TLB vector",
@@ -87,5 +87,5 @@
 };
 
-static const char *vector_names_16_bundle[VECTORS_16_BUNDLE] = {
+char *vector_names_16_bundle[VECTORS_16_BUNDLE] = {
 	"Page Not Present vector",
 	"Key Permission vector",
@@ -121,5 +121,8 @@
 };
 
-static const char *vector_to_string(uint16_t vector)
+static char *vector_to_string(uint16_t vector);
+static void dump_interrupted_context(istate_t *istate);
+
+char *vector_to_string(uint16_t vector)
 {
 	ASSERT(vector <= VECTOR_MAX);
@@ -132,10 +135,12 @@
 }
 
-static void dump_interrupted_context(istate_t *istate)
-{
-	const char *ifa = symtab_fmt_name_lookup(istate->cr_ifa);
-	const char *iipa = symtab_fmt_name_lookup(istate->cr_iipa);
-	const char *iip = symtab_fmt_name_lookup(istate->cr_iip);
-	
+void dump_interrupted_context(istate_t *istate)
+{
+	char *ifa, *iipa, *iip;
+
+	ifa = symtab_fmt_name_lookup(istate->cr_ifa);
+	iipa = symtab_fmt_name_lookup(istate->cr_iipa);
+	iip = symtab_fmt_name_lookup(istate->cr_iip);
+
 	putchar('\n');
 	printf("Interrupted context dump:\n");
@@ -157,6 +162,6 @@
 void general_exception(uint64_t vector, istate_t *istate)
 {
-	const char *desc;
-	
+	char *desc = "";
+
 	switch (istate->cr_isr.ge_code) {
 	case GE_ILLEGALOP:
@@ -182,7 +187,7 @@
 		break;
 	}
-	
+
 	fault_if_from_uspace(istate, "General Exception (%s).", desc);
-	
+
 	dump_interrupted_context(istate);
 	panic("General Exception (%s).", desc);
Index: kernel/arch/mips32/include/atomic.h
===================================================================
--- kernel/arch/mips32/include/atomic.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/mips32/include/atomic.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup mips32
+/** @addtogroup mips32	
  * @{
  */
@@ -51,10 +51,8 @@
  *
  * @return Value after addition.
- *
  */
-static inline atomic_count_t atomic_add(atomic_t *val, atomic_count_t i)
+static inline long atomic_add(atomic_t *val, int i)
 {
-	atomic_count_t tmp;
-	atomic_count_t v;
+	long tmp, v;
 	
 	asm volatile (
@@ -66,9 +64,6 @@
 		"	beq %0, %4, 1b\n"   /* if the atomic operation failed, try again */
 		"	nop\n"
-		: "=&r" (tmp),
-		  "+m" (val->count),
-		  "=&r" (v)
-		: "r" (i),
-		  "i" (0)
+		: "=&r" (tmp), "+m" (val->count), "=&r" (v)
+		: "r" (i), "i" (0)
 	);
 	
@@ -76,8 +71,6 @@
 }
 
-static inline atomic_count_t test_and_set(atomic_t *val)
-{
-	atomic_count_t tmp;
-	atomic_count_t v;
+static inline uint32_t test_and_set(atomic_t *val) {
+	uint32_t tmp, v;
 	
 	asm volatile (
@@ -89,7 +82,5 @@
 		"	beqz %0, 1b\n"
 		"2:\n"
-		: "=&r" (tmp),
-		  "+m" (val->count),
-		  "=&r" (v)
+		: "=&r" (tmp), "+m" (val->count), "=&r" (v)
 		: "i" (1)
 	);
@@ -98,8 +89,8 @@
 }
 
-static inline void atomic_lock_arch(atomic_t *val)
-{
+static inline void atomic_lock_arch(atomic_t *val) {
 	do {
-		while (val->count);
+		while (val->count)
+			;
 	} while (test_and_set(val));
 }
Index: kernel/arch/mips32/include/types.h
===================================================================
--- kernel/arch/mips32/include/types.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/mips32/include/types.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup mips32
+/** @addtogroup mips32	
  * @{
  */
@@ -55,5 +55,4 @@
 typedef uint32_t unative_t;
 typedef int32_t native_t;
-typedef uint32_t atomic_count_t;
 
 typedef struct {
Index: kernel/arch/mips32/src/cpu/cpu.c
===================================================================
--- kernel/arch/mips32/src/cpu/cpu.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/mips32/src/cpu/cpu.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -40,6 +40,6 @@
 
 struct data_t {
-	const char *vendor;
-	const char *model;
+	char *vendor;
+	char *model;
 };
 
Index: kernel/arch/mips32/src/debugger.c
===================================================================
--- kernel/arch/mips32/src/debugger.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/mips32/src/debugger.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -253,13 +253,14 @@
 {
 	unsigned int i;
+	char *symbol;
 	
 	printf("#  Count Address    INPROG ONESHOT FUNCCALL In symbol\n");
 	printf("-- ----- ---------- ------ ------- -------- ---------\n");
 	
-	for (i = 0; i < BKPOINTS_MAX; i++) {
+	for (i = 0; i < BKPOINTS_MAX; i++)
 		if (breakpoints[i].address) {
-			const char *symbol = symtab_fmt_name_lookup(
+			symbol = symtab_fmt_name_lookup(
 			    breakpoints[i].address);
-			
+
 			printf("%-2u %-5d %#10zx %-6s %-7s %-8s %s\n", i,
 			    breakpoints[i].counter, breakpoints[i].address,
@@ -269,6 +270,4 @@
 			    BKPOINT_FUNCCALL) ? "true" : "false"), symbol);
 		}
-	}
-	
 	return 1;
 }
Index: kernel/arch/mips32/src/exception.c
===================================================================
--- kernel/arch/mips32/src/exception.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/mips32/src/exception.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -49,5 +49,5 @@
 #include <symtab.h>
 
-static const char *exctable[] = {
+static char * exctable[] = {
 	"Interrupt",
 	"TLB Modified",
@@ -74,7 +74,9 @@
 static void print_regdump(istate_t *istate)
 {
-	const char *pcsymbol = symtab_fmt_name_lookup(istate->epc);
-	const char *rasymbol = symtab_fmt_name_lookup(istate->ra);
-	
+	char *pcsymbol, *rasymbol;
+
+	pcsymbol = symtab_fmt_name_lookup(istate->epc);
+	rasymbol = symtab_fmt_name_lookup(istate->ra);
+
 	printf("PC: %#x(%s) RA: %#x(%s), SP(%p)\n", istate->epc, pcsymbol,
 	    istate->ra, rasymbol, istate->sp);
@@ -91,9 +93,9 @@
 static void reserved_instr_exception(int n, istate_t *istate)
 {
-	if (*((uint32_t *) istate->epc) == 0x7c03e83b) {
+	if (*((uint32_t *)istate->epc) == 0x7c03e83b) {
 		ASSERT(THREAD);
 		istate->epc += 4;
 		istate->v1 = istate->k1;
-	} else
+	} else 
 		unhandled_exception(n, istate);
 }
Index: kernel/arch/mips32/src/mm/tlb.c
===================================================================
--- kernel/arch/mips32/src/mm/tlb.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/mips32/src/mm/tlb.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -321,6 +321,8 @@
 void tlb_refill_fail(istate_t *istate)
 {
-	const char *symbol = symtab_fmt_name_lookup(istate->epc);
-	const char *sym2 = symtab_fmt_name_lookup(istate->ra);
+	char *symbol, *sym2;
+
+	symbol = symtab_fmt_name_lookup(istate->epc);
+	sym2 = symtab_fmt_name_lookup(istate->ra);
 	
 	fault_if_from_uspace(istate, "TLB Refill Exception on %p.",
@@ -333,6 +335,8 @@
 void tlb_invalid_fail(istate_t *istate)
 {
-	const char *symbol = symtab_fmt_name_lookup(istate->epc);
-	
+	char *symbol;
+
+	symbol = symtab_fmt_name_lookup(istate->epc);
+
 	fault_if_from_uspace(istate, "TLB Invalid Exception on %p.",
 	    cp0_badvaddr_read());
@@ -343,6 +347,8 @@
 void tlb_modified_fail(istate_t *istate)
 {
-	const char *symbol = symtab_fmt_name_lookup(istate->epc);
-	
+	char *symbol;
+
+	symbol = symtab_fmt_name_lookup(istate->epc);
+
 	fault_if_from_uspace(istate, "TLB Modified Exception on %p.",
 	    cp0_badvaddr_read());
Index: kernel/arch/ppc32/include/atomic.h
===================================================================
--- kernel/arch/ppc32/include/atomic.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/ppc32/include/atomic.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup ppc32
+/** @addtogroup ppc32	
  * @{
  */
@@ -38,6 +38,6 @@
 static inline void atomic_inc(atomic_t *val)
 {
-	atomic_count_t tmp;
-	
+	long tmp;
+
 	asm volatile (
 		"1:\n"
@@ -46,8 +46,6 @@
 		"stwcx. %0, 0, %2\n"
 		"bne- 1b"
-		: "=&r" (tmp),
-		  "=m" (val->count)
-		: "r" (&val->count),
-		  "m" (val->count)
+		: "=&r" (tmp), "=m" (val->count)
+		: "r" (&val->count), "m" (val->count)
 		: "cc"
 	);
@@ -56,21 +54,19 @@
 static inline void atomic_dec(atomic_t *val)
 {
-	atomic_count_t tmp;
-	
+	long tmp;
+
 	asm volatile (
 		"1:\n"
 		"lwarx %0, 0, %2\n"
 		"addic %0, %0, -1\n"
-		"stwcx. %0, 0, %2\n"
+		"stwcx.	%0, 0, %2\n"
 		"bne- 1b"
-		: "=&r" (tmp),
-		  "=m" (val->count)
-		: "r" (&val->count),
-		  "m" (val->count)
+		: "=&r" (tmp), "=m" (val->count)
+		: "r" (&val->count), "m" (val->count)
 		: "cc"
 	);
 }
 
-static inline atomic_count_t atomic_postinc(atomic_t *val)
+static inline long atomic_postinc(atomic_t *val)
 {
 	atomic_inc(val);
@@ -78,5 +74,5 @@
 }
 
-static inline atomic_count_t atomic_postdec(atomic_t *val)
+static inline long atomic_postdec(atomic_t *val)
 {
 	atomic_dec(val);
@@ -84,5 +80,5 @@
 }
 
-static inline atomic_count_t atomic_preinc(atomic_t *val)
+static inline long atomic_preinc(atomic_t *val)
 {
 	atomic_inc(val);
@@ -90,5 +86,5 @@
 }
 
-static inline atomic_count_t atomic_predec(atomic_t *val)
+static inline long atomic_predec(atomic_t *val)
 {
 	atomic_dec(val);
Index: kernel/arch/ppc32/include/types.h
===================================================================
--- kernel/arch/ppc32/include/types.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/ppc32/include/types.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup ppc32
+/** @addtogroup ppc32	
  * @{
  */
@@ -55,5 +55,4 @@
 typedef uint32_t unative_t;
 typedef int32_t native_t;
-typedef uint32_t atomic_count_t;
 
 typedef struct {
Index: kernel/arch/ppc32/src/cpu/cpu.c
===================================================================
--- kernel/arch/ppc32/src/cpu/cpu.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/ppc32/src/cpu/cpu.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -54,5 +54,5 @@
 void cpu_print_report(cpu_t *m)
 {
-	const char *name;
+	char *name;
 	
 	switch (m->arch.version) {
Index: kernel/arch/ppc32/src/mm/tlb.c
===================================================================
--- kernel/arch/ppc32/src/mm/tlb.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/ppc32/src/mm/tlb.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -114,7 +114,10 @@
 static void pht_refill_fail(uintptr_t badvaddr, istate_t *istate)
 {
-	const char *symbol = symtab_fmt_name_lookup(istate->pc);
-	const char *sym2 = symtab_fmt_name_lookup(istate->lr);
-	
+	char *symbol;
+	char *sym2;
+
+	symbol = symtab_fmt_name_lookup(istate->pc);
+	sym2 = symtab_fmt_name_lookup(istate->lr);
+
 	fault_if_from_uspace(istate,
 	    "PHT Refill Exception on %p.", badvaddr);
